### Summary of Examples

| Example        | Description or Summary                                                                                                                                                 | 
| ------------- |------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|[acl](https://github.com/membrane/service-proxy/tree/master/distribution/examples/acl) | Restrict access to APIs by ip address or hostname.                                                                                                                     |
|[api-management](https://github.com/membrane/service-proxy/tree/master/distribution/examples/api-management)| A simple file based api management approach.                                                                                                                           |
|[basic-auth](https://github.com/membrane/service-proxy/tree/master/distribution/examples/basic-auth)| _HTTP Basic Authentication_ to secure APIs or Web pages with username and password.                                                                                    |
|[basic-xml-interceptor](https://github.com/membrane/service-proxy/tree/master/distribution/examples/basic-xml-interceptor)| BasicXmlInterceptor adds date element with current time information inside bar element.                                                                                |
|[cbr](https://github.com/membrane/service-proxy/tree/master/distribution/examples/cbr)| Content based routing using XPath.                                                                                                                                     
|[custom-interceptor](https://github.com/membrane/service-proxy/tree/master/distribution/examples/custom-interceptor)| How to write custom interceptors in Java.                                                                                                                              |
|[custom-websocket-interceptor](https://github.com/membrane/service-proxy/tree/master/distribution/examples/custom-websocket-interceptor)| Please visit https://www.membrane-soa.org/service-proxy-doc/current/websockets/create-websocket-interceptor.htm to learn how to create custom WebSocket interceptors.  |
|[docker](https://github.com/membrane/service-proxy/tree/master/distribution/examples/docker)| How to create a Membrane docker image.                                                                                                                                 |
|[embedding-java](https://github.com/membrane/service-proxy/tree/master/distribution/examples/embedding-java)| How to embed Membrane into Java applications.                                                                                                                          |
|[file-exchangestore](https://github.com/membrane/service-proxy/tree/master/distribution/examples/file-exchangestore)| Membrane uses exchange stores to save requests and responses on disc or memory.                                                                                        |
|[groovy](https://github.com/membrane/service-proxy/tree/master/distribution/examples/groovy)| Run groovy scripts to manipulate or monitor messages.                                                                                                                  |
|[javascript](https://github.com/membrane/service-proxy/tree/master/distribution/examples/javascript)| Manipulate and monitor messages with Javascript.                                                                                                                       |
|[json2json-transformation](https://github.com/membrane/service-proxy/tree/master/distribution/examples/json2json-transformation)| Transforms a JSON document into another JSON document using Javascript.                                                                                                |
|[json-2-xml](https://github.com/membrane/service-proxy/tree/master/distribution/examples/json-2-xml)| Using `json2xml` interceptor you can convert JSON content to XML in both request and response.                                                                         |
|[loadbalancing](loadbalancing)| From simple static laodbalancers to dynamic node management                                                                                                            |
|[logging](https://github.com/membrane/service-proxy/tree/master/distribution/examples/logging)| How to log requests and responses into a file and database in text, CSV and JSON format.                                                                               |
|[login page](https://github.com/membrane/service-proxy/tree/master/distribution/examples/login)| Protect Web pages using a login page and passwords.                                                                                                                    |
|[ntlm](https://github.com/membrane/service-proxy/tree/master/distribution/examples/ntlm)| Authentication against NTLM protected backends e.g. running on Microsoft IIS                                                                                           |
|[oauth2](https://github.com/membrane/service-proxy/tree/master/distribution/examples/oauth2)| Please follow https://www.membrane-soa.org/service-proxy-doc/current/oauth2-password-flow-sample.htm                                                                   |
|[openapi](openapi)| Load APIs from OpenAPI documents and validate requests and responses against OpenAPI.                                                                                  |
|[proxy](https://github.com/membrane/service-proxy/tree/master/distribution/examples/proxy)| How to forward HTTP requests to a proxy. Membrane can also serve as an HTTP proxy itself. The example demonstrates both.                                               |
|[quickstart-rest](https://github.com/membrane/service-proxy/tree/master/distribution/examples/quickstart-rest)| Please follow http://membrane-soa.org/service-proxy-doc/current/rest-quickstart.htm .                                                                                  |
|[quickstart-soap](https://github.com/membrane/service-proxy/tree/master/distribution/examples/quickstart-soap)| Please follow http://membrane-soa.org/service-proxy-doc/current/soap-quickstart.htm .                                                                                  |
|[rateLimiter](https://github.com/membrane/service-proxy/tree/master/distribution/examples/rateLimiter)| The `RateLimiter` limits the number of requests in a given interval.                                                                                                   |
|[rest2soap](https://github.com/membrane/service-proxy/tree/master/distribution/examples/rest2soap)| With the REST2SOAP Converter you can make a SOAP Web Service as a REST resource accessible.                                                                            |
|[rest2soap-json](https://github.com/membrane/service-proxy/tree/master/distribution/examples/rest2soap-json)| `REST2SOAP` converter exposes a SOAP Web Service as a REST resource. In contrast to the rest2soap example the response will be a JSON object.                          |
|[rewriter](https://github.com/membrane/service-proxy/tree/master/distribution/examples/rewriter)| With the `RewriteInterceptor` you can rewrite URLs using regular expressions.                                                                                          |
|[service-discovery-with-etcd](https://github.com/membrane/service-proxy/tree/master/distribution/examples/service-discovery-with-etcd)| The publisher publishes endpoint details for services to "the cloud". The configurator reads those details from "the cloud" and dynamically forwards to those services |
|[soap/add-soap-header](https://github.com/membrane/service-proxy/tree/master/distribution/examples/soap/add-soap-header)| This interceptor adds a SOAP header to the incoming request using the Java DOM API.                                                                                    |
|[spel](https://github.com/membrane/service-proxy/tree/master/distribution/examples/spel)| Using the Spring Expression language as part of router configuration.                                                                                                  |
|[SSL/TLS](ssl)| SSL for APIs and for the communication to backends                                                                                                                     |
|[stax-interceptor](https://github.com/membrane/service-proxy/tree/master/distribution/examples/stax-interceptor)| In this example we will install an interceptor called StaxConverterInterceptor that changes tag name from `<foo>` to `<bar>` using Java STAX API.                      |
|[stomp-over-websocket-intercepting](https://github.com/membrane/service-proxy/tree/master/distribution/examples/stomp-over-websocket-intercepting)| In this example we are going to see how STOMP-over-WebSocket messages are routed through Membrane Service Proxy.                                                       |
|[swagger-proxy](https://github.com/membrane/service-proxy/tree/master/distribution/examples/swagger-proxy)| Running a proxy for Swagger using Membrane.                                                                                                                            |
|[template](https://github.com/membrane/service-proxy/tree/master/distribution/examples/template)| With the Template Plugin you can intercept request and responses and change them using templates.                                                                      |
|[throttle](https://github.com/membrane/service-proxy/tree/master/distribution/examples/throttle)| With the `ThrottleInterceptor` you can delay and limit parallel requests.                                                                                              |
|[validation](https://github.com/membrane/service-proxy/tree/master/distribution/examples/validation)| Contains examples about form, xml schema, schematron, json-schema and soap proxy validation                                                                            |
|[versioning](https://github.com/membrane/service-proxy/tree/master/distribution/examples/versioning)| Examples showcasing routing and xslt versioning                                                                                                                        |
|[websocket-intercepting](https://github.com/membrane/service-proxy/tree/master/distribution/examples/websocket-intercepting)| This example demonstrates how Websocket frames are routed through Membrane Service Proxy.                                                                              |
|[websocket-stomp](https://github.com/membrane/service-proxy/tree/master/distribution/examples/websocket-stomp)| STOMP over WebSocket, all handled by Membrane Service Proxy.                                                                                                           |
|[xml-2-json](https://github.com/membrane/service-proxy/tree/master/distribution/examples/xml-2-json)| Using `xml2json` interceptor you can convert XML content to JSON in both request and response.                                                                         |
|[xslt](https://github.com/membrane/service-proxy/tree/master/distribution/examples/xslt)| XSLTInterceptor applying XSLT stylesheets to request and response.                                                                                                     |
